﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2022.1.3),
    on May 25, 2023, at 09:51
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

from psychopy import locale_setup
from psychopy import prefs
from psychopy import sound, gui, visual, core, data, event, logging, clock, colors, layout
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle, choice as randchoice
import os  # handy system and path functions
import sys  # to get file system encoding

import psychopy.iohub as io
from psychopy.hardware import keyboard



# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)
# Store info about the experiment session
psychopyVersion = '2022.1.3'
expName = 'midEEG'  # from the Builder filename that created this script
expInfo = {'participant': '', 'session': '001'}
dlg = gui.DlgFromDict(dictionary=expInfo, sortKeys=False, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='C:\\Users\\selin\\Documents\\PhD\\Projects\\Community Study 1\\ERP Tasks\\BrainProducts\\MID Task - BP EEG\\midEEG.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run after the window creation

# Setup the Window
win = visual.Window(
    size=[1920, 1080], fullscr=True, screen=0, 
    winType='pyglet', allowGUI=False, allowStencil=False,
    monitor='testMonitor', color=[0,0,0], colorSpace='rgb',
    blendMode='avg', useFBO=True, 
    units='height')
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess
# Setup ioHub
ioConfig = {}

# Setup iohub keyboard
ioConfig['Keyboard'] = dict(use_keymap='psychopy')

ioSession = '1'
if 'session' in expInfo:
    ioSession = str(expInfo['session'])
ioServer = io.launchHubServer(window=win, **ioConfig)
eyetracker = None

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard(backend='iohub')

# Initialize components for Routine "intro"
introClock = core.Clock()
instruct = visual.TextStim(win=win, name='instruct',
    text='In this task the aim is respond to a white square presented on the screen. \n\nFirst you will see a triangle or £ , followed by a small cross and then a white square. \n\nYou will need to click on this white square as soon as it appears, it is important that you click ON the white square.  \n\nWhen you see a triangle it does not matter whether you click in time, this will not influence the feedback you receive. \n\nBut after seeing a £ you will stand to win 20p or lose 20p, depending on how quickly you respond. \n\nPlease press the space bar to begin a practice run.',
    font='Open Sans',
    pos=(0, 0), height=0.035, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
instruct_key_resp = keyboard.Keyboard()

# Initialize components for Routine "cue"
cueClock = core.Clock()
cue_condition = visual.ImageStim(
    win=win,
    name='cue_condition', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=[0.25, 0.25],
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=0.0)
anticipation = visual.TextStim(win=win, name='anticipation',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.15, wrapWidth=None, ori=0.0, 
    color=[-1.0000, -1.0000, -1.0000], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "target"
targetClock = core.Clock()
jitter = visual.TextStim(win=win, name='jitter',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
jitter_cross = visual.TextStim(win=win, name='jitter_cross',
    text='*',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);
#define initial response duration
resp_duration = 0.2
target_stim = visual.ImageStim(
    win=win,
    name='target_stim', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(0.24, 0.24),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-4.0)
target_mouse = event.Mouse(win=win)
x, y = [None, None]
target_mouse.mouseClock = core.Clock()

# Initialize components for Routine "feedback"
feedbackClock = core.Clock()
#define earning variables
total_earnings = 0
this_earnings = 0 
fixation_cross = visual.TextStim(win=win, name='fixation_cross',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.15, wrapWidth=None, ori=0.0, 
    color=[-1.0000, -1.0000, -1.0000], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
feedback_stim = visual.ImageStim(
    win=win,
    name='feedback_stim', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(0.25, 0.25),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-2.0)

# Initialize components for Routine "ITI"
ITIClock = core.Clock()
ITI_stimulus = visual.TextStim(win=win, name='ITI_stimulus',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "task_begin"
task_beginClock = core.Clock()
task_begin_text = visual.TextStim(win=win, name='task_begin_text',
    text='You have now finished the practice run. \n\nRemember you will need to click on this white square as soon as it appears, it is important that you click ON the white square.  \n\nWhen you see a triangle it does not matter whether you click in time, this will not influence the feedback you receive. But after seeing a £ you will stand to win 20p or lose 20p, depending on how quickly you respond. \n\nPress the spacebar when you are ready to begin the main task. ',
    font='Open Sans',
    pos=(0, 0), height=0.035, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
key_resp = keyboard.Keyboard()

# Initialize components for Routine "cue"
cueClock = core.Clock()
cue_condition = visual.ImageStim(
    win=win,
    name='cue_condition', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=[0.25, 0.25],
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=0.0)
anticipation = visual.TextStim(win=win, name='anticipation',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.15, wrapWidth=None, ori=0.0, 
    color=[-1.0000, -1.0000, -1.0000], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "target"
targetClock = core.Clock()
jitter = visual.TextStim(win=win, name='jitter',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
jitter_cross = visual.TextStim(win=win, name='jitter_cross',
    text='*',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);
#define initial response duration
resp_duration = 0.2
target_stim = visual.ImageStim(
    win=win,
    name='target_stim', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(0.24, 0.24),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-4.0)
target_mouse = event.Mouse(win=win)
x, y = [None, None]
target_mouse.mouseClock = core.Clock()

# Initialize components for Routine "feedback"
feedbackClock = core.Clock()
#define earning variables
total_earnings = 0
this_earnings = 0 
fixation_cross = visual.TextStim(win=win, name='fixation_cross',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.15, wrapWidth=None, ori=0.0, 
    color=[-1.0000, -1.0000, -1.0000], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
feedback_stim = visual.ImageStim(
    win=win,
    name='feedback_stim', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(0.25, 0.25),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-2.0)

# Initialize components for Routine "ITI"
ITIClock = core.Clock()
ITI_stimulus = visual.TextStim(win=win, name='ITI_stimulus',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "task_break"
task_breakClock = core.Clock()
taskbreak_text = visual.TextStim(win=win, name='taskbreak_text',
    text='You have now completed the first block. \n\nYou have two blocks left to go. \n\nRemember you will need to click on this white square as soon as it appears, it is important that you click ON the white square.  \n\nWhen you see a triangle it does not matter whether you click in time, this will not influence the feedback you receive. But after seeing a £ you will stand to win 20p or lose 20p, depending on how quickly you respond. ',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
taskbreak_key_resp = keyboard.Keyboard()

# Initialize components for Routine "cue"
cueClock = core.Clock()
cue_condition = visual.ImageStim(
    win=win,
    name='cue_condition', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=[0.25, 0.25],
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=0.0)
anticipation = visual.TextStim(win=win, name='anticipation',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.15, wrapWidth=None, ori=0.0, 
    color=[-1.0000, -1.0000, -1.0000], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "target"
targetClock = core.Clock()
jitter = visual.TextStim(win=win, name='jitter',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
jitter_cross = visual.TextStim(win=win, name='jitter_cross',
    text='*',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);
#define initial response duration
resp_duration = 0.2
target_stim = visual.ImageStim(
    win=win,
    name='target_stim', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(0.24, 0.24),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-4.0)
target_mouse = event.Mouse(win=win)
x, y = [None, None]
target_mouse.mouseClock = core.Clock()

# Initialize components for Routine "feedback"
feedbackClock = core.Clock()
#define earning variables
total_earnings = 0
this_earnings = 0 
fixation_cross = visual.TextStim(win=win, name='fixation_cross',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.15, wrapWidth=None, ori=0.0, 
    color=[-1.0000, -1.0000, -1.0000], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
feedback_stim = visual.ImageStim(
    win=win,
    name='feedback_stim', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(0.25, 0.25),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-2.0)

# Initialize components for Routine "ITI"
ITIClock = core.Clock()
ITI_stimulus = visual.TextStim(win=win, name='ITI_stimulus',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "task_break_2"
task_break_2Clock = core.Clock()
task_break2_text = visual.TextStim(win=win, name='task_break2_text',
    text='You have now completed the first two blocks. \n\nYou have one block left to go. \n\nPlease press the space bar when you are ready to continue. ',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
taskbreak2_key_resp = keyboard.Keyboard()

# Initialize components for Routine "cue"
cueClock = core.Clock()
cue_condition = visual.ImageStim(
    win=win,
    name='cue_condition', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=[0.25, 0.25],
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=0.0)
anticipation = visual.TextStim(win=win, name='anticipation',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.15, wrapWidth=None, ori=0.0, 
    color=[-1.0000, -1.0000, -1.0000], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "target"
targetClock = core.Clock()
jitter = visual.TextStim(win=win, name='jitter',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
jitter_cross = visual.TextStim(win=win, name='jitter_cross',
    text='*',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);
#define initial response duration
resp_duration = 0.2
target_stim = visual.ImageStim(
    win=win,
    name='target_stim', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(0.24, 0.24),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-4.0)
target_mouse = event.Mouse(win=win)
x, y = [None, None]
target_mouse.mouseClock = core.Clock()

# Initialize components for Routine "feedback"
feedbackClock = core.Clock()
#define earning variables
total_earnings = 0
this_earnings = 0 
fixation_cross = visual.TextStim(win=win, name='fixation_cross',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.15, wrapWidth=None, ori=0.0, 
    color=[-1.0000, -1.0000, -1.0000], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
feedback_stim = visual.ImageStim(
    win=win,
    name='feedback_stim', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(0.25, 0.25),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-2.0)

# Initialize components for Routine "ITI"
ITIClock = core.Clock()
ITI_stimulus = visual.TextStim(win=win, name='ITI_stimulus',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "end"
endClock = core.Clock()
end_text = visual.TextStim(win=win, name='end_text',
    text='You have now finished the task. \n\nPlease feel free to take a short break. ',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# ------Prepare to start Routine "intro"-------
continueRoutine = True
# update component parameters for each repeat
instruct_key_resp.keys = []
instruct_key_resp.rt = []
_instruct_key_resp_allKeys = []
# keep track of which components have finished
introComponents = [instruct, instruct_key_resp]
for thisComponent in introComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
introClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "intro"-------
while continueRoutine:
    # get current time
    t = introClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=introClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *instruct* updates
    if instruct.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        instruct.frameNStart = frameN  # exact frame index
        instruct.tStart = t  # local t and not account for scr refresh
        instruct.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(instruct, 'tStartRefresh')  # time at next scr refresh
        instruct.setAutoDraw(True)
    
    # *instruct_key_resp* updates
    waitOnFlip = False
    if instruct_key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        instruct_key_resp.frameNStart = frameN  # exact frame index
        instruct_key_resp.tStart = t  # local t and not account for scr refresh
        instruct_key_resp.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(instruct_key_resp, 'tStartRefresh')  # time at next scr refresh
        instruct_key_resp.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(instruct_key_resp.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(instruct_key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if instruct_key_resp.status == STARTED and not waitOnFlip:
        theseKeys = instruct_key_resp.getKeys(keyList=['space'], waitRelease=False)
        _instruct_key_resp_allKeys.extend(theseKeys)
        if len(_instruct_key_resp_allKeys):
            instruct_key_resp.keys = _instruct_key_resp_allKeys[-1].name  # just the last key pressed
            instruct_key_resp.rt = _instruct_key_resp_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in introComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "intro"-------
for thisComponent in introComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('instruct.started', instruct.tStartRefresh)
thisExp.addData('instruct.stopped', instruct.tStopRefresh)
# check responses
if instruct_key_resp.keys in ['', [], None]:  # No response was made
    instruct_key_resp.keys = None
thisExp.addData('instruct_key_resp.keys',instruct_key_resp.keys)
if instruct_key_resp.keys != None:  # we had a response
    thisExp.addData('instruct_key_resp.rt', instruct_key_resp.rt)
thisExp.addData('instruct_key_resp.started', instruct_key_resp.tStartRefresh)
thisExp.addData('instruct_key_resp.stopped', instruct_key_resp.tStopRefresh)
thisExp.nextEntry()
# the Routine "intro" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
practice_run = data.TrialHandler(nReps=2.0, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('condition.xlsx'),
    seed=None, name='practice_run')
thisExp.addLoop(practice_run)  # add the loop to the experiment
thisPractice_run = practice_run.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisPractice_run.rgb)
if thisPractice_run != None:
    for paramName in thisPractice_run:
        exec('{} = thisPractice_run[paramName]'.format(paramName))

for thisPractice_run in practice_run:
    currentLoop = practice_run
    # abbreviate parameter names if possible (e.g. rgb = thisPractice_run.rgb)
    if thisPractice_run != None:
        for paramName in thisPractice_run:
            exec('{} = thisPractice_run[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "cue"-------
    continueRoutine = True
    routineTimer.add(1.200000)
    # update component parameters for each repeat
    cue_condition.setImage(cue_type)
    # keep track of which components have finished
    cueComponents = [cue_condition, anticipation]
    for thisComponent in cueComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    cueClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "cue"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = cueClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=cueClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *cue_condition* updates
        if cue_condition.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            cue_condition.frameNStart = frameN  # exact frame index
            cue_condition.tStart = t  # local t and not account for scr refresh
            cue_condition.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(cue_condition, 'tStartRefresh')  # time at next scr refresh
            cue_condition.setAutoDraw(True)
        if cue_condition.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > cue_condition.tStartRefresh + 0.4-frameTolerance:
                # keep track of stop time/frame for later
                cue_condition.tStop = t  # not accounting for scr refresh
                cue_condition.frameNStop = frameN  # exact frame index
                win.timeOnFlip(cue_condition, 'tStopRefresh')  # time at next scr refresh
                cue_condition.setAutoDraw(False)
        
        # *anticipation* updates
        if anticipation.status == NOT_STARTED and tThisFlip >= 0.4-frameTolerance:
            # keep track of start time/frame for later
            anticipation.frameNStart = frameN  # exact frame index
            anticipation.tStart = t  # local t and not account for scr refresh
            anticipation.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(anticipation, 'tStartRefresh')  # time at next scr refresh
            anticipation.setAutoDraw(True)
        if anticipation.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > anticipation.tStartRefresh + 0.8-frameTolerance:
                # keep track of stop time/frame for later
                anticipation.tStop = t  # not accounting for scr refresh
                anticipation.frameNStop = frameN  # exact frame index
                win.timeOnFlip(anticipation, 'tStopRefresh')  # time at next scr refresh
                anticipation.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in cueComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "cue"-------
    for thisComponent in cueComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    practice_run.addData('cue_condition.started', cue_condition.tStartRefresh)
    practice_run.addData('cue_condition.stopped', cue_condition.tStopRefresh)
    practice_run.addData('anticipation.started', anticipation.tStartRefresh)
    practice_run.addData('anticipation.stopped', anticipation.tStopRefresh)
    
    # ------Prepare to start Routine "target"-------
    continueRoutine = True
    # update component parameters for each repeat
    randOnset = random() *(1.5 - 0.5) + 0.5
    thisExp.addData("randOnset", randOnset)
    jitter.setText(randOnset)
    #define correst response variable
    correct = 0
    target_stim.setImage('square.png')
    # setup some python lists for storing info about the target_mouse
    target_mouse.x = []
    target_mouse.y = []
    target_mouse.leftButton = []
    target_mouse.midButton = []
    target_mouse.rightButton = []
    target_mouse.time = []
    target_mouse.clicked_name = []
    gotValidClick = False  # until a click is received
    # keep track of which components have finished
    targetComponents = [jitter, jitter_cross, target_stim, target_mouse]
    for thisComponent in targetComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    targetClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "target"-------
    while continueRoutine:
        # get current time
        t = targetClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=targetClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *jitter* updates
        if jitter.status == NOT_STARTED and tThisFlip >= randOnset + 0.7-frameTolerance:
            # keep track of start time/frame for later
            jitter.frameNStart = frameN  # exact frame index
            jitter.tStart = t  # local t and not account for scr refresh
            jitter.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(jitter, 'tStartRefresh')  # time at next scr refresh
            jitter.setAutoDraw(True)
        if jitter.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > jitter.tStartRefresh + 0.5-frameTolerance:
                # keep track of stop time/frame for later
                jitter.tStop = t  # not accounting for scr refresh
                jitter.frameNStop = frameN  # exact frame index
                win.timeOnFlip(jitter, 'tStopRefresh')  # time at next scr refresh
                jitter.setAutoDraw(False)
        
        # *jitter_cross* updates
        if jitter_cross.status == NOT_STARTED and tThisFlip >= 0.2-frameTolerance:
            # keep track of start time/frame for later
            jitter_cross.frameNStart = frameN  # exact frame index
            jitter_cross.tStart = t  # local t and not account for scr refresh
            jitter_cross.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(jitter_cross, 'tStartRefresh')  # time at next scr refresh
            jitter_cross.setAutoDraw(True)
        if jitter_cross.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > jitter_cross.tStartRefresh + 0.5-frameTolerance:
                # keep track of stop time/frame for later
                jitter_cross.tStop = t  # not accounting for scr refresh
                jitter_cross.frameNStop = frameN  # exact frame index
                win.timeOnFlip(jitter_cross, 'tStopRefresh')  # time at next scr refresh
                jitter_cross.setAutoDraw(False)
        #check correct response
        if target_mouse.isPressedIn(target_stim):
                correct = 1
                continueRoutine = False
        else: 
            correct = 0 
            continueRoutine = False
        
        # *target_stim* updates
        if target_stim.status == NOT_STARTED and tThisFlip >= 0.7-frameTolerance:
            # keep track of start time/frame for later
            target_stim.frameNStart = frameN  # exact frame index
            target_stim.tStart = t  # local t and not account for scr refresh
            target_stim.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(target_stim, 'tStartRefresh')  # time at next scr refresh
            target_stim.setAutoDraw(True)
        if target_stim.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > target_stim.tStartRefresh + resp_duration-frameTolerance:
                # keep track of stop time/frame for later
                target_stim.tStop = t  # not accounting for scr refresh
                target_stim.frameNStop = frameN  # exact frame index
                win.timeOnFlip(target_stim, 'tStopRefresh')  # time at next scr refresh
                target_stim.setAutoDraw(False)
        # *target_mouse* updates
        if target_mouse.status == NOT_STARTED and t >= 0.7-frameTolerance:
            # keep track of start time/frame for later
            target_mouse.frameNStart = frameN  # exact frame index
            target_mouse.tStart = t  # local t and not account for scr refresh
            target_mouse.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(target_mouse, 'tStartRefresh')  # time at next scr refresh
            target_mouse.status = STARTED
            target_mouse.mouseClock.reset()
            prevButtonState = target_mouse.getPressed()  # if button is down already this ISN'T a new click
        if target_mouse.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > target_mouse.tStartRefresh + resp_duration-frameTolerance:
                # keep track of stop time/frame for later
                target_mouse.tStop = t  # not accounting for scr refresh
                target_mouse.frameNStop = frameN  # exact frame index
                win.timeOnFlip(target_mouse, 'tStopRefresh')  # time at next scr refresh
                target_mouse.status = FINISHED
        if target_mouse.status == STARTED:  # only update if started and not finished!
            buttons = target_mouse.getPressed()
            if buttons != prevButtonState:  # button state changed?
                prevButtonState = buttons
                if sum(buttons) > 0:  # state changed to a new click
                    # check if the mouse was inside our 'clickable' objects
                    gotValidClick = False
                    try:
                        iter(target_stim)
                        clickableList = target_stim
                    except:
                        clickableList = [target_stim]
                    for obj in clickableList:
                        if obj.contains(target_mouse):
                            gotValidClick = True
                            target_mouse.clicked_name.append(obj.name)
                    if gotValidClick:
                        x, y = target_mouse.getPos()
                        target_mouse.x.append(x)
                        target_mouse.y.append(y)
                        buttons = target_mouse.getPressed()
                        target_mouse.leftButton.append(buttons[0])
                        target_mouse.midButton.append(buttons[1])
                        target_mouse.rightButton.append(buttons[2])
                        target_mouse.time.append(target_mouse.mouseClock.getTime())
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in targetComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "target"-------
    for thisComponent in targetComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    practice_run.addData('jitter.started', jitter.tStartRefresh)
    practice_run.addData('jitter.stopped', jitter.tStopRefresh)
    practice_run.addData('jitter_cross.started', jitter_cross.tStartRefresh)
    practice_run.addData('jitter_cross.stopped', jitter_cross.tStopRefresh)
    if correct == 1:
        resp_duration -= 0.01
    else:
        resp_duration += 0.01
    
    #saving custon data to csv output
    thisExp.addData("resp_duration", resp_duration)
    practice_run.addData('target_stim.started', target_stim.tStartRefresh)
    practice_run.addData('target_stim.stopped', target_stim.tStopRefresh)
    # store data for practice_run (TrialHandler)
    practice_run.addData('target_mouse.x', target_mouse.x)
    practice_run.addData('target_mouse.y', target_mouse.y)
    practice_run.addData('target_mouse.leftButton', target_mouse.leftButton)
    practice_run.addData('target_mouse.midButton', target_mouse.midButton)
    practice_run.addData('target_mouse.rightButton', target_mouse.rightButton)
    practice_run.addData('target_mouse.time', target_mouse.time)
    practice_run.addData('target_mouse.clicked_name', target_mouse.clicked_name)
    practice_run.addData('target_mouse.started', target_mouse.tStart)
    practice_run.addData('target_mouse.stopped', target_mouse.tStop)
    # the Routine "target" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # ------Prepare to start Routine "feedback"-------
    continueRoutine = True
    routineTimer.add(2.800000)
    # update component parameters for each repeat
    #show different feedback depending on trial type
    #set trigger values based on trial type
    if trial_type == "incentive":
        if correct == 1:
            image_feedback = "win.jpg"
            this_earnings = 0.2
            feedback_trigger = 4
        else:
            image_feedback = "loss.png"
            this_earnings = -0.2
            feedback_trigger = 5
    else:
        image_feedback = "neutral.png"
        this_earnings = 0
        feedback_trigger = 6
    
    total_earnings = total_earnings + this_earnings
    thisExp.addData ("total_earnings", total_earnings)
    
    thisExp.addData("correct", correct)
    feedback_stim.setImage(image_feedback)
    # keep track of which components have finished
    feedbackComponents = [fixation_cross, feedback_stim]
    for thisComponent in feedbackComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    feedbackClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "feedback"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = feedbackClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=feedbackClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *fixation_cross* updates
        if fixation_cross.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            fixation_cross.frameNStart = frameN  # exact frame index
            fixation_cross.tStart = t  # local t and not account for scr refresh
            fixation_cross.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(fixation_cross, 'tStartRefresh')  # time at next scr refresh
            fixation_cross.setAutoDraw(True)
        if fixation_cross.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > fixation_cross.tStartRefresh + 0.8-frameTolerance:
                # keep track of stop time/frame for later
                fixation_cross.tStop = t  # not accounting for scr refresh
                fixation_cross.frameNStop = frameN  # exact frame index
                win.timeOnFlip(fixation_cross, 'tStopRefresh')  # time at next scr refresh
                fixation_cross.setAutoDraw(False)
        
        # *feedback_stim* updates
        if feedback_stim.status == NOT_STARTED and tThisFlip >= 0.8-frameTolerance:
            # keep track of start time/frame for later
            feedback_stim.frameNStart = frameN  # exact frame index
            feedback_stim.tStart = t  # local t and not account for scr refresh
            feedback_stim.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(feedback_stim, 'tStartRefresh')  # time at next scr refresh
            feedback_stim.setAutoDraw(True)
        if feedback_stim.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > feedback_stim.tStartRefresh + 2-frameTolerance:
                # keep track of stop time/frame for later
                feedback_stim.tStop = t  # not accounting for scr refresh
                feedback_stim.frameNStop = frameN  # exact frame index
                win.timeOnFlip(feedback_stim, 'tStopRefresh')  # time at next scr refresh
                feedback_stim.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in feedbackComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "feedback"-------
    for thisComponent in feedbackComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    practice_run.addData('fixation_cross.started', fixation_cross.tStartRefresh)
    practice_run.addData('fixation_cross.stopped', fixation_cross.tStopRefresh)
    practice_run.addData('feedback_stim.started', feedback_stim.tStartRefresh)
    practice_run.addData('feedback_stim.stopped', feedback_stim.tStopRefresh)
    
    # ------Prepare to start Routine "ITI"-------
    continueRoutine = True
    # update component parameters for each repeat
    #randomly generate number from 0 to 1
    random_n = random()
    
    possible_times = [0.6, 0.7]
    
    #randomly pick which times to add randomly
    #generated number
    shuffle(possible_times)
    
    this_time = possible_times[0]
    
    #equation to get ITI
    ITI_time = this_time + random_n/10
    print(ITI_time)
    
    thisExp.addData ("ITI_time", ITI_time)
    # keep track of which components have finished
    ITIComponents = [ITI_stimulus]
    for thisComponent in ITIComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    ITIClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "ITI"-------
    while continueRoutine:
        # get current time
        t = ITIClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=ITIClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *ITI_stimulus* updates
        if ITI_stimulus.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            ITI_stimulus.frameNStart = frameN  # exact frame index
            ITI_stimulus.tStart = t  # local t and not account for scr refresh
            ITI_stimulus.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(ITI_stimulus, 'tStartRefresh')  # time at next scr refresh
            ITI_stimulus.setAutoDraw(True)
        if ITI_stimulus.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > ITI_stimulus.tStartRefresh + ITI_time-frameTolerance:
                # keep track of stop time/frame for later
                ITI_stimulus.tStop = t  # not accounting for scr refresh
                ITI_stimulus.frameNStop = frameN  # exact frame index
                win.timeOnFlip(ITI_stimulus, 'tStopRefresh')  # time at next scr refresh
                ITI_stimulus.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in ITIComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "ITI"-------
    for thisComponent in ITIComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    practice_run.addData('ITI_stimulus.started', ITI_stimulus.tStartRefresh)
    practice_run.addData('ITI_stimulus.stopped', ITI_stimulus.tStopRefresh)
    # the Routine "ITI" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 2.0 repeats of 'practice_run'


# ------Prepare to start Routine "task_begin"-------
continueRoutine = True
# update component parameters for each repeat
key_resp.keys = []
key_resp.rt = []
_key_resp_allKeys = []
# keep track of which components have finished
task_beginComponents = [task_begin_text, key_resp]
for thisComponent in task_beginComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
task_beginClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "task_begin"-------
while continueRoutine:
    # get current time
    t = task_beginClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=task_beginClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *task_begin_text* updates
    if task_begin_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        task_begin_text.frameNStart = frameN  # exact frame index
        task_begin_text.tStart = t  # local t and not account for scr refresh
        task_begin_text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(task_begin_text, 'tStartRefresh')  # time at next scr refresh
        task_begin_text.setAutoDraw(True)
    
    # *key_resp* updates
    waitOnFlip = False
    if key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        key_resp.frameNStart = frameN  # exact frame index
        key_resp.tStart = t  # local t and not account for scr refresh
        key_resp.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(key_resp, 'tStartRefresh')  # time at next scr refresh
        key_resp.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(key_resp.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if key_resp.status == STARTED and not waitOnFlip:
        theseKeys = key_resp.getKeys(keyList=['space'], waitRelease=False)
        _key_resp_allKeys.extend(theseKeys)
        if len(_key_resp_allKeys):
            key_resp.keys = _key_resp_allKeys[-1].name  # just the last key pressed
            key_resp.rt = _key_resp_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in task_beginComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "task_begin"-------
for thisComponent in task_beginComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('task_begin_text.started', task_begin_text.tStartRefresh)
thisExp.addData('task_begin_text.stopped', task_begin_text.tStopRefresh)
# check responses
if key_resp.keys in ['', [], None]:  # No response was made
    key_resp.keys = None
thisExp.addData('key_resp.keys',key_resp.keys)
if key_resp.keys != None:  # we had a response
    thisExp.addData('key_resp.rt', key_resp.rt)
thisExp.addData('key_resp.started', key_resp.tStartRefresh)
thisExp.addData('key_resp.stopped', key_resp.tStopRefresh)
thisExp.nextEntry()
# the Routine "task_begin" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
block1 = data.TrialHandler(nReps=17.0, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('condition.xlsx'),
    seed=None, name='block1')
thisExp.addLoop(block1)  # add the loop to the experiment
thisBlock1 = block1.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisBlock1.rgb)
if thisBlock1 != None:
    for paramName in thisBlock1:
        exec('{} = thisBlock1[paramName]'.format(paramName))

for thisBlock1 in block1:
    currentLoop = block1
    # abbreviate parameter names if possible (e.g. rgb = thisBlock1.rgb)
    if thisBlock1 != None:
        for paramName in thisBlock1:
            exec('{} = thisBlock1[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "cue"-------
    continueRoutine = True
    routineTimer.add(1.200000)
    # update component parameters for each repeat
    cue_condition.setImage(cue_type)
    # keep track of which components have finished
    cueComponents = [cue_condition, anticipation]
    for thisComponent in cueComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    cueClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "cue"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = cueClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=cueClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *cue_condition* updates
        if cue_condition.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            cue_condition.frameNStart = frameN  # exact frame index
            cue_condition.tStart = t  # local t and not account for scr refresh
            cue_condition.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(cue_condition, 'tStartRefresh')  # time at next scr refresh
            cue_condition.setAutoDraw(True)
        if cue_condition.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > cue_condition.tStartRefresh + 0.4-frameTolerance:
                # keep track of stop time/frame for later
                cue_condition.tStop = t  # not accounting for scr refresh
                cue_condition.frameNStop = frameN  # exact frame index
                win.timeOnFlip(cue_condition, 'tStopRefresh')  # time at next scr refresh
                cue_condition.setAutoDraw(False)
        
        # *anticipation* updates
        if anticipation.status == NOT_STARTED and tThisFlip >= 0.4-frameTolerance:
            # keep track of start time/frame for later
            anticipation.frameNStart = frameN  # exact frame index
            anticipation.tStart = t  # local t and not account for scr refresh
            anticipation.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(anticipation, 'tStartRefresh')  # time at next scr refresh
            anticipation.setAutoDraw(True)
        if anticipation.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > anticipation.tStartRefresh + 0.8-frameTolerance:
                # keep track of stop time/frame for later
                anticipation.tStop = t  # not accounting for scr refresh
                anticipation.frameNStop = frameN  # exact frame index
                win.timeOnFlip(anticipation, 'tStopRefresh')  # time at next scr refresh
                anticipation.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in cueComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "cue"-------
    for thisComponent in cueComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    block1.addData('cue_condition.started', cue_condition.tStartRefresh)
    block1.addData('cue_condition.stopped', cue_condition.tStopRefresh)
    block1.addData('anticipation.started', anticipation.tStartRefresh)
    block1.addData('anticipation.stopped', anticipation.tStopRefresh)
    
    # ------Prepare to start Routine "target"-------
    continueRoutine = True
    # update component parameters for each repeat
    randOnset = random() *(1.5 - 0.5) + 0.5
    thisExp.addData("randOnset", randOnset)
    jitter.setText(randOnset)
    #define correst response variable
    correct = 0
    target_stim.setImage('square.png')
    # setup some python lists for storing info about the target_mouse
    target_mouse.x = []
    target_mouse.y = []
    target_mouse.leftButton = []
    target_mouse.midButton = []
    target_mouse.rightButton = []
    target_mouse.time = []
    target_mouse.clicked_name = []
    gotValidClick = False  # until a click is received
    # keep track of which components have finished
    targetComponents = [jitter, jitter_cross, target_stim, target_mouse]
    for thisComponent in targetComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    targetClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "target"-------
    while continueRoutine:
        # get current time
        t = targetClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=targetClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *jitter* updates
        if jitter.status == NOT_STARTED and tThisFlip >= randOnset + 0.7-frameTolerance:
            # keep track of start time/frame for later
            jitter.frameNStart = frameN  # exact frame index
            jitter.tStart = t  # local t and not account for scr refresh
            jitter.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(jitter, 'tStartRefresh')  # time at next scr refresh
            jitter.setAutoDraw(True)
        if jitter.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > jitter.tStartRefresh + 0.5-frameTolerance:
                # keep track of stop time/frame for later
                jitter.tStop = t  # not accounting for scr refresh
                jitter.frameNStop = frameN  # exact frame index
                win.timeOnFlip(jitter, 'tStopRefresh')  # time at next scr refresh
                jitter.setAutoDraw(False)
        
        # *jitter_cross* updates
        if jitter_cross.status == NOT_STARTED and tThisFlip >= 0.2-frameTolerance:
            # keep track of start time/frame for later
            jitter_cross.frameNStart = frameN  # exact frame index
            jitter_cross.tStart = t  # local t and not account for scr refresh
            jitter_cross.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(jitter_cross, 'tStartRefresh')  # time at next scr refresh
            jitter_cross.setAutoDraw(True)
        if jitter_cross.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > jitter_cross.tStartRefresh + 0.5-frameTolerance:
                # keep track of stop time/frame for later
                jitter_cross.tStop = t  # not accounting for scr refresh
                jitter_cross.frameNStop = frameN  # exact frame index
                win.timeOnFlip(jitter_cross, 'tStopRefresh')  # time at next scr refresh
                jitter_cross.setAutoDraw(False)
        #check correct response
        if target_mouse.isPressedIn(target_stim):
                correct = 1
                continueRoutine = False
        else: 
            correct = 0 
            continueRoutine = False
        
        # *target_stim* updates
        if target_stim.status == NOT_STARTED and tThisFlip >= 0.7-frameTolerance:
            # keep track of start time/frame for later
            target_stim.frameNStart = frameN  # exact frame index
            target_stim.tStart = t  # local t and not account for scr refresh
            target_stim.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(target_stim, 'tStartRefresh')  # time at next scr refresh
            target_stim.setAutoDraw(True)
        if target_stim.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > target_stim.tStartRefresh + resp_duration-frameTolerance:
                # keep track of stop time/frame for later
                target_stim.tStop = t  # not accounting for scr refresh
                target_stim.frameNStop = frameN  # exact frame index
                win.timeOnFlip(target_stim, 'tStopRefresh')  # time at next scr refresh
                target_stim.setAutoDraw(False)
        # *target_mouse* updates
        if target_mouse.status == NOT_STARTED and t >= 0.7-frameTolerance:
            # keep track of start time/frame for later
            target_mouse.frameNStart = frameN  # exact frame index
            target_mouse.tStart = t  # local t and not account for scr refresh
            target_mouse.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(target_mouse, 'tStartRefresh')  # time at next scr refresh
            target_mouse.status = STARTED
            target_mouse.mouseClock.reset()
            prevButtonState = target_mouse.getPressed()  # if button is down already this ISN'T a new click
        if target_mouse.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > target_mouse.tStartRefresh + resp_duration-frameTolerance:
                # keep track of stop time/frame for later
                target_mouse.tStop = t  # not accounting for scr refresh
                target_mouse.frameNStop = frameN  # exact frame index
                win.timeOnFlip(target_mouse, 'tStopRefresh')  # time at next scr refresh
                target_mouse.status = FINISHED
        if target_mouse.status == STARTED:  # only update if started and not finished!
            buttons = target_mouse.getPressed()
            if buttons != prevButtonState:  # button state changed?
                prevButtonState = buttons
                if sum(buttons) > 0:  # state changed to a new click
                    # check if the mouse was inside our 'clickable' objects
                    gotValidClick = False
                    try:
                        iter(target_stim)
                        clickableList = target_stim
                    except:
                        clickableList = [target_stim]
                    for obj in clickableList:
                        if obj.contains(target_mouse):
                            gotValidClick = True
                            target_mouse.clicked_name.append(obj.name)
                    if gotValidClick:
                        x, y = target_mouse.getPos()
                        target_mouse.x.append(x)
                        target_mouse.y.append(y)
                        buttons = target_mouse.getPressed()
                        target_mouse.leftButton.append(buttons[0])
                        target_mouse.midButton.append(buttons[1])
                        target_mouse.rightButton.append(buttons[2])
                        target_mouse.time.append(target_mouse.mouseClock.getTime())
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in targetComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "target"-------
    for thisComponent in targetComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    block1.addData('jitter.started', jitter.tStartRefresh)
    block1.addData('jitter.stopped', jitter.tStopRefresh)
    block1.addData('jitter_cross.started', jitter_cross.tStartRefresh)
    block1.addData('jitter_cross.stopped', jitter_cross.tStopRefresh)
    if correct == 1:
        resp_duration -= 0.01
    else:
        resp_duration += 0.01
    
    #saving custon data to csv output
    thisExp.addData("resp_duration", resp_duration)
    block1.addData('target_stim.started', target_stim.tStartRefresh)
    block1.addData('target_stim.stopped', target_stim.tStopRefresh)
    # store data for block1 (TrialHandler)
    block1.addData('target_mouse.x', target_mouse.x)
    block1.addData('target_mouse.y', target_mouse.y)
    block1.addData('target_mouse.leftButton', target_mouse.leftButton)
    block1.addData('target_mouse.midButton', target_mouse.midButton)
    block1.addData('target_mouse.rightButton', target_mouse.rightButton)
    block1.addData('target_mouse.time', target_mouse.time)
    block1.addData('target_mouse.clicked_name', target_mouse.clicked_name)
    block1.addData('target_mouse.started', target_mouse.tStart)
    block1.addData('target_mouse.stopped', target_mouse.tStop)
    # the Routine "target" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # ------Prepare to start Routine "feedback"-------
    continueRoutine = True
    routineTimer.add(2.800000)
    # update component parameters for each repeat
    #show different feedback depending on trial type
    #set trigger values based on trial type
    if trial_type == "incentive":
        if correct == 1:
            image_feedback = "win.jpg"
            this_earnings = 0.2
            feedback_trigger = 4
        else:
            image_feedback = "loss.png"
            this_earnings = -0.2
            feedback_trigger = 5
    else:
        image_feedback = "neutral.png"
        this_earnings = 0
        feedback_trigger = 6
    
    total_earnings = total_earnings + this_earnings
    thisExp.addData ("total_earnings", total_earnings)
    
    thisExp.addData("correct", correct)
    feedback_stim.setImage(image_feedback)
    # keep track of which components have finished
    feedbackComponents = [fixation_cross, feedback_stim]
    for thisComponent in feedbackComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    feedbackClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "feedback"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = feedbackClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=feedbackClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *fixation_cross* updates
        if fixation_cross.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            fixation_cross.frameNStart = frameN  # exact frame index
            fixation_cross.tStart = t  # local t and not account for scr refresh
            fixation_cross.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(fixation_cross, 'tStartRefresh')  # time at next scr refresh
            fixation_cross.setAutoDraw(True)
        if fixation_cross.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > fixation_cross.tStartRefresh + 0.8-frameTolerance:
                # keep track of stop time/frame for later
                fixation_cross.tStop = t  # not accounting for scr refresh
                fixation_cross.frameNStop = frameN  # exact frame index
                win.timeOnFlip(fixation_cross, 'tStopRefresh')  # time at next scr refresh
                fixation_cross.setAutoDraw(False)
        
        # *feedback_stim* updates
        if feedback_stim.status == NOT_STARTED and tThisFlip >= 0.8-frameTolerance:
            # keep track of start time/frame for later
            feedback_stim.frameNStart = frameN  # exact frame index
            feedback_stim.tStart = t  # local t and not account for scr refresh
            feedback_stim.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(feedback_stim, 'tStartRefresh')  # time at next scr refresh
            feedback_stim.setAutoDraw(True)
        if feedback_stim.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > feedback_stim.tStartRefresh + 2-frameTolerance:
                # keep track of stop time/frame for later
                feedback_stim.tStop = t  # not accounting for scr refresh
                feedback_stim.frameNStop = frameN  # exact frame index
                win.timeOnFlip(feedback_stim, 'tStopRefresh')  # time at next scr refresh
                feedback_stim.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in feedbackComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "feedback"-------
    for thisComponent in feedbackComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    block1.addData('fixation_cross.started', fixation_cross.tStartRefresh)
    block1.addData('fixation_cross.stopped', fixation_cross.tStopRefresh)
    block1.addData('feedback_stim.started', feedback_stim.tStartRefresh)
    block1.addData('feedback_stim.stopped', feedback_stim.tStopRefresh)
    
    # ------Prepare to start Routine "ITI"-------
    continueRoutine = True
    # update component parameters for each repeat
    #randomly generate number from 0 to 1
    random_n = random()
    
    possible_times = [0.6, 0.7]
    
    #randomly pick which times to add randomly
    #generated number
    shuffle(possible_times)
    
    this_time = possible_times[0]
    
    #equation to get ITI
    ITI_time = this_time + random_n/10
    print(ITI_time)
    
    thisExp.addData ("ITI_time", ITI_time)
    # keep track of which components have finished
    ITIComponents = [ITI_stimulus]
    for thisComponent in ITIComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    ITIClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "ITI"-------
    while continueRoutine:
        # get current time
        t = ITIClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=ITIClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *ITI_stimulus* updates
        if ITI_stimulus.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            ITI_stimulus.frameNStart = frameN  # exact frame index
            ITI_stimulus.tStart = t  # local t and not account for scr refresh
            ITI_stimulus.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(ITI_stimulus, 'tStartRefresh')  # time at next scr refresh
            ITI_stimulus.setAutoDraw(True)
        if ITI_stimulus.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > ITI_stimulus.tStartRefresh + ITI_time-frameTolerance:
                # keep track of stop time/frame for later
                ITI_stimulus.tStop = t  # not accounting for scr refresh
                ITI_stimulus.frameNStop = frameN  # exact frame index
                win.timeOnFlip(ITI_stimulus, 'tStopRefresh')  # time at next scr refresh
                ITI_stimulus.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in ITIComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "ITI"-------
    for thisComponent in ITIComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    block1.addData('ITI_stimulus.started', ITI_stimulus.tStartRefresh)
    block1.addData('ITI_stimulus.stopped', ITI_stimulus.tStopRefresh)
    # the Routine "ITI" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 17.0 repeats of 'block1'


# ------Prepare to start Routine "task_break"-------
continueRoutine = True
# update component parameters for each repeat
taskbreak_key_resp.keys = []
taskbreak_key_resp.rt = []
_taskbreak_key_resp_allKeys = []
# keep track of which components have finished
task_breakComponents = [taskbreak_text, taskbreak_key_resp]
for thisComponent in task_breakComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
task_breakClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "task_break"-------
while continueRoutine:
    # get current time
    t = task_breakClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=task_breakClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *taskbreak_text* updates
    if taskbreak_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        taskbreak_text.frameNStart = frameN  # exact frame index
        taskbreak_text.tStart = t  # local t and not account for scr refresh
        taskbreak_text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(taskbreak_text, 'tStartRefresh')  # time at next scr refresh
        taskbreak_text.setAutoDraw(True)
    
    # *taskbreak_key_resp* updates
    waitOnFlip = False
    if taskbreak_key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        taskbreak_key_resp.frameNStart = frameN  # exact frame index
        taskbreak_key_resp.tStart = t  # local t and not account for scr refresh
        taskbreak_key_resp.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(taskbreak_key_resp, 'tStartRefresh')  # time at next scr refresh
        taskbreak_key_resp.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(taskbreak_key_resp.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(taskbreak_key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if taskbreak_key_resp.status == STARTED and not waitOnFlip:
        theseKeys = taskbreak_key_resp.getKeys(keyList=['space'], waitRelease=False)
        _taskbreak_key_resp_allKeys.extend(theseKeys)
        if len(_taskbreak_key_resp_allKeys):
            taskbreak_key_resp.keys = _taskbreak_key_resp_allKeys[-1].name  # just the last key pressed
            taskbreak_key_resp.rt = _taskbreak_key_resp_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in task_breakComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "task_break"-------
for thisComponent in task_breakComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('taskbreak_text.started', taskbreak_text.tStartRefresh)
thisExp.addData('taskbreak_text.stopped', taskbreak_text.tStopRefresh)
# check responses
if taskbreak_key_resp.keys in ['', [], None]:  # No response was made
    taskbreak_key_resp.keys = None
thisExp.addData('taskbreak_key_resp.keys',taskbreak_key_resp.keys)
if taskbreak_key_resp.keys != None:  # we had a response
    thisExp.addData('taskbreak_key_resp.rt', taskbreak_key_resp.rt)
thisExp.addData('taskbreak_key_resp.started', taskbreak_key_resp.tStartRefresh)
thisExp.addData('taskbreak_key_resp.stopped', taskbreak_key_resp.tStopRefresh)
thisExp.nextEntry()
# the Routine "task_break" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
block2 = data.TrialHandler(nReps=17.0, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('condition.xlsx'),
    seed=None, name='block2')
thisExp.addLoop(block2)  # add the loop to the experiment
thisBlock2 = block2.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisBlock2.rgb)
if thisBlock2 != None:
    for paramName in thisBlock2:
        exec('{} = thisBlock2[paramName]'.format(paramName))

for thisBlock2 in block2:
    currentLoop = block2
    # abbreviate parameter names if possible (e.g. rgb = thisBlock2.rgb)
    if thisBlock2 != None:
        for paramName in thisBlock2:
            exec('{} = thisBlock2[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "cue"-------
    continueRoutine = True
    routineTimer.add(1.200000)
    # update component parameters for each repeat
    cue_condition.setImage(cue_type)
    # keep track of which components have finished
    cueComponents = [cue_condition, anticipation]
    for thisComponent in cueComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    cueClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "cue"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = cueClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=cueClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *cue_condition* updates
        if cue_condition.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            cue_condition.frameNStart = frameN  # exact frame index
            cue_condition.tStart = t  # local t and not account for scr refresh
            cue_condition.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(cue_condition, 'tStartRefresh')  # time at next scr refresh
            cue_condition.setAutoDraw(True)
        if cue_condition.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > cue_condition.tStartRefresh + 0.4-frameTolerance:
                # keep track of stop time/frame for later
                cue_condition.tStop = t  # not accounting for scr refresh
                cue_condition.frameNStop = frameN  # exact frame index
                win.timeOnFlip(cue_condition, 'tStopRefresh')  # time at next scr refresh
                cue_condition.setAutoDraw(False)
        
        # *anticipation* updates
        if anticipation.status == NOT_STARTED and tThisFlip >= 0.4-frameTolerance:
            # keep track of start time/frame for later
            anticipation.frameNStart = frameN  # exact frame index
            anticipation.tStart = t  # local t and not account for scr refresh
            anticipation.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(anticipation, 'tStartRefresh')  # time at next scr refresh
            anticipation.setAutoDraw(True)
        if anticipation.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > anticipation.tStartRefresh + 0.8-frameTolerance:
                # keep track of stop time/frame for later
                anticipation.tStop = t  # not accounting for scr refresh
                anticipation.frameNStop = frameN  # exact frame index
                win.timeOnFlip(anticipation, 'tStopRefresh')  # time at next scr refresh
                anticipation.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in cueComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "cue"-------
    for thisComponent in cueComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    block2.addData('cue_condition.started', cue_condition.tStartRefresh)
    block2.addData('cue_condition.stopped', cue_condition.tStopRefresh)
    block2.addData('anticipation.started', anticipation.tStartRefresh)
    block2.addData('anticipation.stopped', anticipation.tStopRefresh)
    
    # ------Prepare to start Routine "target"-------
    continueRoutine = True
    # update component parameters for each repeat
    randOnset = random() *(1.5 - 0.5) + 0.5
    thisExp.addData("randOnset", randOnset)
    jitter.setText(randOnset)
    #define correst response variable
    correct = 0
    target_stim.setImage('square.png')
    # setup some python lists for storing info about the target_mouse
    target_mouse.x = []
    target_mouse.y = []
    target_mouse.leftButton = []
    target_mouse.midButton = []
    target_mouse.rightButton = []
    target_mouse.time = []
    target_mouse.clicked_name = []
    gotValidClick = False  # until a click is received
    # keep track of which components have finished
    targetComponents = [jitter, jitter_cross, target_stim, target_mouse]
    for thisComponent in targetComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    targetClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "target"-------
    while continueRoutine:
        # get current time
        t = targetClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=targetClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *jitter* updates
        if jitter.status == NOT_STARTED and tThisFlip >= randOnset + 0.7-frameTolerance:
            # keep track of start time/frame for later
            jitter.frameNStart = frameN  # exact frame index
            jitter.tStart = t  # local t and not account for scr refresh
            jitter.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(jitter, 'tStartRefresh')  # time at next scr refresh
            jitter.setAutoDraw(True)
        if jitter.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > jitter.tStartRefresh + 0.5-frameTolerance:
                # keep track of stop time/frame for later
                jitter.tStop = t  # not accounting for scr refresh
                jitter.frameNStop = frameN  # exact frame index
                win.timeOnFlip(jitter, 'tStopRefresh')  # time at next scr refresh
                jitter.setAutoDraw(False)
        
        # *jitter_cross* updates
        if jitter_cross.status == NOT_STARTED and tThisFlip >= 0.2-frameTolerance:
            # keep track of start time/frame for later
            jitter_cross.frameNStart = frameN  # exact frame index
            jitter_cross.tStart = t  # local t and not account for scr refresh
            jitter_cross.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(jitter_cross, 'tStartRefresh')  # time at next scr refresh
            jitter_cross.setAutoDraw(True)
        if jitter_cross.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > jitter_cross.tStartRefresh + 0.5-frameTolerance:
                # keep track of stop time/frame for later
                jitter_cross.tStop = t  # not accounting for scr refresh
                jitter_cross.frameNStop = frameN  # exact frame index
                win.timeOnFlip(jitter_cross, 'tStopRefresh')  # time at next scr refresh
                jitter_cross.setAutoDraw(False)
        #check correct response
        if target_mouse.isPressedIn(target_stim):
                correct = 1
                continueRoutine = False
        else: 
            correct = 0 
            continueRoutine = False
        
        # *target_stim* updates
        if target_stim.status == NOT_STARTED and tThisFlip >= 0.7-frameTolerance:
            # keep track of start time/frame for later
            target_stim.frameNStart = frameN  # exact frame index
            target_stim.tStart = t  # local t and not account for scr refresh
            target_stim.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(target_stim, 'tStartRefresh')  # time at next scr refresh
            target_stim.setAutoDraw(True)
        if target_stim.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > target_stim.tStartRefresh + resp_duration-frameTolerance:
                # keep track of stop time/frame for later
                target_stim.tStop = t  # not accounting for scr refresh
                target_stim.frameNStop = frameN  # exact frame index
                win.timeOnFlip(target_stim, 'tStopRefresh')  # time at next scr refresh
                target_stim.setAutoDraw(False)
        # *target_mouse* updates
        if target_mouse.status == NOT_STARTED and t >= 0.7-frameTolerance:
            # keep track of start time/frame for later
            target_mouse.frameNStart = frameN  # exact frame index
            target_mouse.tStart = t  # local t and not account for scr refresh
            target_mouse.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(target_mouse, 'tStartRefresh')  # time at next scr refresh
            target_mouse.status = STARTED
            target_mouse.mouseClock.reset()
            prevButtonState = target_mouse.getPressed()  # if button is down already this ISN'T a new click
        if target_mouse.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > target_mouse.tStartRefresh + resp_duration-frameTolerance:
                # keep track of stop time/frame for later
                target_mouse.tStop = t  # not accounting for scr refresh
                target_mouse.frameNStop = frameN  # exact frame index
                win.timeOnFlip(target_mouse, 'tStopRefresh')  # time at next scr refresh
                target_mouse.status = FINISHED
        if target_mouse.status == STARTED:  # only update if started and not finished!
            buttons = target_mouse.getPressed()
            if buttons != prevButtonState:  # button state changed?
                prevButtonState = buttons
                if sum(buttons) > 0:  # state changed to a new click
                    # check if the mouse was inside our 'clickable' objects
                    gotValidClick = False
                    try:
                        iter(target_stim)
                        clickableList = target_stim
                    except:
                        clickableList = [target_stim]
                    for obj in clickableList:
                        if obj.contains(target_mouse):
                            gotValidClick = True
                            target_mouse.clicked_name.append(obj.name)
                    if gotValidClick:
                        x, y = target_mouse.getPos()
                        target_mouse.x.append(x)
                        target_mouse.y.append(y)
                        buttons = target_mouse.getPressed()
                        target_mouse.leftButton.append(buttons[0])
                        target_mouse.midButton.append(buttons[1])
                        target_mouse.rightButton.append(buttons[2])
                        target_mouse.time.append(target_mouse.mouseClock.getTime())
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in targetComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "target"-------
    for thisComponent in targetComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    block2.addData('jitter.started', jitter.tStartRefresh)
    block2.addData('jitter.stopped', jitter.tStopRefresh)
    block2.addData('jitter_cross.started', jitter_cross.tStartRefresh)
    block2.addData('jitter_cross.stopped', jitter_cross.tStopRefresh)
    if correct == 1:
        resp_duration -= 0.01
    else:
        resp_duration += 0.01
    
    #saving custon data to csv output
    thisExp.addData("resp_duration", resp_duration)
    block2.addData('target_stim.started', target_stim.tStartRefresh)
    block2.addData('target_stim.stopped', target_stim.tStopRefresh)
    # store data for block2 (TrialHandler)
    block2.addData('target_mouse.x', target_mouse.x)
    block2.addData('target_mouse.y', target_mouse.y)
    block2.addData('target_mouse.leftButton', target_mouse.leftButton)
    block2.addData('target_mouse.midButton', target_mouse.midButton)
    block2.addData('target_mouse.rightButton', target_mouse.rightButton)
    block2.addData('target_mouse.time', target_mouse.time)
    block2.addData('target_mouse.clicked_name', target_mouse.clicked_name)
    block2.addData('target_mouse.started', target_mouse.tStart)
    block2.addData('target_mouse.stopped', target_mouse.tStop)
    # the Routine "target" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # ------Prepare to start Routine "feedback"-------
    continueRoutine = True
    routineTimer.add(2.800000)
    # update component parameters for each repeat
    #show different feedback depending on trial type
    #set trigger values based on trial type
    if trial_type == "incentive":
        if correct == 1:
            image_feedback = "win.jpg"
            this_earnings = 0.2
            feedback_trigger = 4
        else:
            image_feedback = "loss.png"
            this_earnings = -0.2
            feedback_trigger = 5
    else:
        image_feedback = "neutral.png"
        this_earnings = 0
        feedback_trigger = 6
    
    total_earnings = total_earnings + this_earnings
    thisExp.addData ("total_earnings", total_earnings)
    
    thisExp.addData("correct", correct)
    feedback_stim.setImage(image_feedback)
    # keep track of which components have finished
    feedbackComponents = [fixation_cross, feedback_stim]
    for thisComponent in feedbackComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    feedbackClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "feedback"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = feedbackClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=feedbackClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *fixation_cross* updates
        if fixation_cross.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            fixation_cross.frameNStart = frameN  # exact frame index
            fixation_cross.tStart = t  # local t and not account for scr refresh
            fixation_cross.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(fixation_cross, 'tStartRefresh')  # time at next scr refresh
            fixation_cross.setAutoDraw(True)
        if fixation_cross.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > fixation_cross.tStartRefresh + 0.8-frameTolerance:
                # keep track of stop time/frame for later
                fixation_cross.tStop = t  # not accounting for scr refresh
                fixation_cross.frameNStop = frameN  # exact frame index
                win.timeOnFlip(fixation_cross, 'tStopRefresh')  # time at next scr refresh
                fixation_cross.setAutoDraw(False)
        
        # *feedback_stim* updates
        if feedback_stim.status == NOT_STARTED and tThisFlip >= 0.8-frameTolerance:
            # keep track of start time/frame for later
            feedback_stim.frameNStart = frameN  # exact frame index
            feedback_stim.tStart = t  # local t and not account for scr refresh
            feedback_stim.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(feedback_stim, 'tStartRefresh')  # time at next scr refresh
            feedback_stim.setAutoDraw(True)
        if feedback_stim.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > feedback_stim.tStartRefresh + 2-frameTolerance:
                # keep track of stop time/frame for later
                feedback_stim.tStop = t  # not accounting for scr refresh
                feedback_stim.frameNStop = frameN  # exact frame index
                win.timeOnFlip(feedback_stim, 'tStopRefresh')  # time at next scr refresh
                feedback_stim.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in feedbackComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "feedback"-------
    for thisComponent in feedbackComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    block2.addData('fixation_cross.started', fixation_cross.tStartRefresh)
    block2.addData('fixation_cross.stopped', fixation_cross.tStopRefresh)
    block2.addData('feedback_stim.started', feedback_stim.tStartRefresh)
    block2.addData('feedback_stim.stopped', feedback_stim.tStopRefresh)
    
    # ------Prepare to start Routine "ITI"-------
    continueRoutine = True
    # update component parameters for each repeat
    #randomly generate number from 0 to 1
    random_n = random()
    
    possible_times = [0.6, 0.7]
    
    #randomly pick which times to add randomly
    #generated number
    shuffle(possible_times)
    
    this_time = possible_times[0]
    
    #equation to get ITI
    ITI_time = this_time + random_n/10
    print(ITI_time)
    
    thisExp.addData ("ITI_time", ITI_time)
    # keep track of which components have finished
    ITIComponents = [ITI_stimulus]
    for thisComponent in ITIComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    ITIClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "ITI"-------
    while continueRoutine:
        # get current time
        t = ITIClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=ITIClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *ITI_stimulus* updates
        if ITI_stimulus.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            ITI_stimulus.frameNStart = frameN  # exact frame index
            ITI_stimulus.tStart = t  # local t and not account for scr refresh
            ITI_stimulus.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(ITI_stimulus, 'tStartRefresh')  # time at next scr refresh
            ITI_stimulus.setAutoDraw(True)
        if ITI_stimulus.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > ITI_stimulus.tStartRefresh + ITI_time-frameTolerance:
                # keep track of stop time/frame for later
                ITI_stimulus.tStop = t  # not accounting for scr refresh
                ITI_stimulus.frameNStop = frameN  # exact frame index
                win.timeOnFlip(ITI_stimulus, 'tStopRefresh')  # time at next scr refresh
                ITI_stimulus.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in ITIComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "ITI"-------
    for thisComponent in ITIComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    block2.addData('ITI_stimulus.started', ITI_stimulus.tStartRefresh)
    block2.addData('ITI_stimulus.stopped', ITI_stimulus.tStopRefresh)
    # the Routine "ITI" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 17.0 repeats of 'block2'


# ------Prepare to start Routine "task_break_2"-------
continueRoutine = True
# update component parameters for each repeat
taskbreak2_key_resp.keys = []
taskbreak2_key_resp.rt = []
_taskbreak2_key_resp_allKeys = []
# keep track of which components have finished
task_break_2Components = [task_break2_text, taskbreak2_key_resp]
for thisComponent in task_break_2Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
task_break_2Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "task_break_2"-------
while continueRoutine:
    # get current time
    t = task_break_2Clock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=task_break_2Clock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *task_break2_text* updates
    if task_break2_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        task_break2_text.frameNStart = frameN  # exact frame index
        task_break2_text.tStart = t  # local t and not account for scr refresh
        task_break2_text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(task_break2_text, 'tStartRefresh')  # time at next scr refresh
        task_break2_text.setAutoDraw(True)
    
    # *taskbreak2_key_resp* updates
    waitOnFlip = False
    if taskbreak2_key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        taskbreak2_key_resp.frameNStart = frameN  # exact frame index
        taskbreak2_key_resp.tStart = t  # local t and not account for scr refresh
        taskbreak2_key_resp.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(taskbreak2_key_resp, 'tStartRefresh')  # time at next scr refresh
        taskbreak2_key_resp.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(taskbreak2_key_resp.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(taskbreak2_key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if taskbreak2_key_resp.status == STARTED and not waitOnFlip:
        theseKeys = taskbreak2_key_resp.getKeys(keyList=['space'], waitRelease=False)
        _taskbreak2_key_resp_allKeys.extend(theseKeys)
        if len(_taskbreak2_key_resp_allKeys):
            taskbreak2_key_resp.keys = _taskbreak2_key_resp_allKeys[-1].name  # just the last key pressed
            taskbreak2_key_resp.rt = _taskbreak2_key_resp_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in task_break_2Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "task_break_2"-------
for thisComponent in task_break_2Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('task_break2_text.started', task_break2_text.tStartRefresh)
thisExp.addData('task_break2_text.stopped', task_break2_text.tStopRefresh)
# check responses
if taskbreak2_key_resp.keys in ['', [], None]:  # No response was made
    taskbreak2_key_resp.keys = None
thisExp.addData('taskbreak2_key_resp.keys',taskbreak2_key_resp.keys)
if taskbreak2_key_resp.keys != None:  # we had a response
    thisExp.addData('taskbreak2_key_resp.rt', taskbreak2_key_resp.rt)
thisExp.addData('taskbreak2_key_resp.started', taskbreak2_key_resp.tStartRefresh)
thisExp.addData('taskbreak2_key_resp.stopped', taskbreak2_key_resp.tStopRefresh)
thisExp.nextEntry()
# the Routine "task_break_2" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
block3 = data.TrialHandler(nReps=17.0, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('condition.xlsx'),
    seed=None, name='block3')
thisExp.addLoop(block3)  # add the loop to the experiment
thisBlock3 = block3.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisBlock3.rgb)
if thisBlock3 != None:
    for paramName in thisBlock3:
        exec('{} = thisBlock3[paramName]'.format(paramName))

for thisBlock3 in block3:
    currentLoop = block3
    # abbreviate parameter names if possible (e.g. rgb = thisBlock3.rgb)
    if thisBlock3 != None:
        for paramName in thisBlock3:
            exec('{} = thisBlock3[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "cue"-------
    continueRoutine = True
    routineTimer.add(1.200000)
    # update component parameters for each repeat
    cue_condition.setImage(cue_type)
    # keep track of which components have finished
    cueComponents = [cue_condition, anticipation]
    for thisComponent in cueComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    cueClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "cue"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = cueClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=cueClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *cue_condition* updates
        if cue_condition.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            cue_condition.frameNStart = frameN  # exact frame index
            cue_condition.tStart = t  # local t and not account for scr refresh
            cue_condition.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(cue_condition, 'tStartRefresh')  # time at next scr refresh
            cue_condition.setAutoDraw(True)
        if cue_condition.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > cue_condition.tStartRefresh + 0.4-frameTolerance:
                # keep track of stop time/frame for later
                cue_condition.tStop = t  # not accounting for scr refresh
                cue_condition.frameNStop = frameN  # exact frame index
                win.timeOnFlip(cue_condition, 'tStopRefresh')  # time at next scr refresh
                cue_condition.setAutoDraw(False)
        
        # *anticipation* updates
        if anticipation.status == NOT_STARTED and tThisFlip >= 0.4-frameTolerance:
            # keep track of start time/frame for later
            anticipation.frameNStart = frameN  # exact frame index
            anticipation.tStart = t  # local t and not account for scr refresh
            anticipation.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(anticipation, 'tStartRefresh')  # time at next scr refresh
            anticipation.setAutoDraw(True)
        if anticipation.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > anticipation.tStartRefresh + 0.8-frameTolerance:
                # keep track of stop time/frame for later
                anticipation.tStop = t  # not accounting for scr refresh
                anticipation.frameNStop = frameN  # exact frame index
                win.timeOnFlip(anticipation, 'tStopRefresh')  # time at next scr refresh
                anticipation.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in cueComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "cue"-------
    for thisComponent in cueComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    block3.addData('cue_condition.started', cue_condition.tStartRefresh)
    block3.addData('cue_condition.stopped', cue_condition.tStopRefresh)
    block3.addData('anticipation.started', anticipation.tStartRefresh)
    block3.addData('anticipation.stopped', anticipation.tStopRefresh)
    
    # ------Prepare to start Routine "target"-------
    continueRoutine = True
    # update component parameters for each repeat
    randOnset = random() *(1.5 - 0.5) + 0.5
    thisExp.addData("randOnset", randOnset)
    jitter.setText(randOnset)
    #define correst response variable
    correct = 0
    target_stim.setImage('square.png')
    # setup some python lists for storing info about the target_mouse
    target_mouse.x = []
    target_mouse.y = []
    target_mouse.leftButton = []
    target_mouse.midButton = []
    target_mouse.rightButton = []
    target_mouse.time = []
    target_mouse.clicked_name = []
    gotValidClick = False  # until a click is received
    # keep track of which components have finished
    targetComponents = [jitter, jitter_cross, target_stim, target_mouse]
    for thisComponent in targetComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    targetClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "target"-------
    while continueRoutine:
        # get current time
        t = targetClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=targetClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *jitter* updates
        if jitter.status == NOT_STARTED and tThisFlip >= randOnset + 0.7-frameTolerance:
            # keep track of start time/frame for later
            jitter.frameNStart = frameN  # exact frame index
            jitter.tStart = t  # local t and not account for scr refresh
            jitter.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(jitter, 'tStartRefresh')  # time at next scr refresh
            jitter.setAutoDraw(True)
        if jitter.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > jitter.tStartRefresh + 0.5-frameTolerance:
                # keep track of stop time/frame for later
                jitter.tStop = t  # not accounting for scr refresh
                jitter.frameNStop = frameN  # exact frame index
                win.timeOnFlip(jitter, 'tStopRefresh')  # time at next scr refresh
                jitter.setAutoDraw(False)
        
        # *jitter_cross* updates
        if jitter_cross.status == NOT_STARTED and tThisFlip >= 0.2-frameTolerance:
            # keep track of start time/frame for later
            jitter_cross.frameNStart = frameN  # exact frame index
            jitter_cross.tStart = t  # local t and not account for scr refresh
            jitter_cross.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(jitter_cross, 'tStartRefresh')  # time at next scr refresh
            jitter_cross.setAutoDraw(True)
        if jitter_cross.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > jitter_cross.tStartRefresh + 0.5-frameTolerance:
                # keep track of stop time/frame for later
                jitter_cross.tStop = t  # not accounting for scr refresh
                jitter_cross.frameNStop = frameN  # exact frame index
                win.timeOnFlip(jitter_cross, 'tStopRefresh')  # time at next scr refresh
                jitter_cross.setAutoDraw(False)
        #check correct response
        if target_mouse.isPressedIn(target_stim):
                correct = 1
                continueRoutine = False
        else: 
            correct = 0 
            continueRoutine = False
        
        # *target_stim* updates
        if target_stim.status == NOT_STARTED and tThisFlip >= 0.7-frameTolerance:
            # keep track of start time/frame for later
            target_stim.frameNStart = frameN  # exact frame index
            target_stim.tStart = t  # local t and not account for scr refresh
            target_stim.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(target_stim, 'tStartRefresh')  # time at next scr refresh
            target_stim.setAutoDraw(True)
        if target_stim.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > target_stim.tStartRefresh + resp_duration-frameTolerance:
                # keep track of stop time/frame for later
                target_stim.tStop = t  # not accounting for scr refresh
                target_stim.frameNStop = frameN  # exact frame index
                win.timeOnFlip(target_stim, 'tStopRefresh')  # time at next scr refresh
                target_stim.setAutoDraw(False)
        # *target_mouse* updates
        if target_mouse.status == NOT_STARTED and t >= 0.7-frameTolerance:
            # keep track of start time/frame for later
            target_mouse.frameNStart = frameN  # exact frame index
            target_mouse.tStart = t  # local t and not account for scr refresh
            target_mouse.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(target_mouse, 'tStartRefresh')  # time at next scr refresh
            target_mouse.status = STARTED
            target_mouse.mouseClock.reset()
            prevButtonState = target_mouse.getPressed()  # if button is down already this ISN'T a new click
        if target_mouse.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > target_mouse.tStartRefresh + resp_duration-frameTolerance:
                # keep track of stop time/frame for later
                target_mouse.tStop = t  # not accounting for scr refresh
                target_mouse.frameNStop = frameN  # exact frame index
                win.timeOnFlip(target_mouse, 'tStopRefresh')  # time at next scr refresh
                target_mouse.status = FINISHED
        if target_mouse.status == STARTED:  # only update if started and not finished!
            buttons = target_mouse.getPressed()
            if buttons != prevButtonState:  # button state changed?
                prevButtonState = buttons
                if sum(buttons) > 0:  # state changed to a new click
                    # check if the mouse was inside our 'clickable' objects
                    gotValidClick = False
                    try:
                        iter(target_stim)
                        clickableList = target_stim
                    except:
                        clickableList = [target_stim]
                    for obj in clickableList:
                        if obj.contains(target_mouse):
                            gotValidClick = True
                            target_mouse.clicked_name.append(obj.name)
                    if gotValidClick:
                        x, y = target_mouse.getPos()
                        target_mouse.x.append(x)
                        target_mouse.y.append(y)
                        buttons = target_mouse.getPressed()
                        target_mouse.leftButton.append(buttons[0])
                        target_mouse.midButton.append(buttons[1])
                        target_mouse.rightButton.append(buttons[2])
                        target_mouse.time.append(target_mouse.mouseClock.getTime())
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in targetComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "target"-------
    for thisComponent in targetComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    block3.addData('jitter.started', jitter.tStartRefresh)
    block3.addData('jitter.stopped', jitter.tStopRefresh)
    block3.addData('jitter_cross.started', jitter_cross.tStartRefresh)
    block3.addData('jitter_cross.stopped', jitter_cross.tStopRefresh)
    if correct == 1:
        resp_duration -= 0.01
    else:
        resp_duration += 0.01
    
    #saving custon data to csv output
    thisExp.addData("resp_duration", resp_duration)
    block3.addData('target_stim.started', target_stim.tStartRefresh)
    block3.addData('target_stim.stopped', target_stim.tStopRefresh)
    # store data for block3 (TrialHandler)
    block3.addData('target_mouse.x', target_mouse.x)
    block3.addData('target_mouse.y', target_mouse.y)
    block3.addData('target_mouse.leftButton', target_mouse.leftButton)
    block3.addData('target_mouse.midButton', target_mouse.midButton)
    block3.addData('target_mouse.rightButton', target_mouse.rightButton)
    block3.addData('target_mouse.time', target_mouse.time)
    block3.addData('target_mouse.clicked_name', target_mouse.clicked_name)
    block3.addData('target_mouse.started', target_mouse.tStart)
    block3.addData('target_mouse.stopped', target_mouse.tStop)
    # the Routine "target" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # ------Prepare to start Routine "feedback"-------
    continueRoutine = True
    routineTimer.add(2.800000)
    # update component parameters for each repeat
    #show different feedback depending on trial type
    #set trigger values based on trial type
    if trial_type == "incentive":
        if correct == 1:
            image_feedback = "win.jpg"
            this_earnings = 0.2
            feedback_trigger = 4
        else:
            image_feedback = "loss.png"
            this_earnings = -0.2
            feedback_trigger = 5
    else:
        image_feedback = "neutral.png"
        this_earnings = 0
        feedback_trigger = 6
    
    total_earnings = total_earnings + this_earnings
    thisExp.addData ("total_earnings", total_earnings)
    
    thisExp.addData("correct", correct)
    feedback_stim.setImage(image_feedback)
    # keep track of which components have finished
    feedbackComponents = [fixation_cross, feedback_stim]
    for thisComponent in feedbackComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    feedbackClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "feedback"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = feedbackClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=feedbackClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *fixation_cross* updates
        if fixation_cross.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            fixation_cross.frameNStart = frameN  # exact frame index
            fixation_cross.tStart = t  # local t and not account for scr refresh
            fixation_cross.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(fixation_cross, 'tStartRefresh')  # time at next scr refresh
            fixation_cross.setAutoDraw(True)
        if fixation_cross.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > fixation_cross.tStartRefresh + 0.8-frameTolerance:
                # keep track of stop time/frame for later
                fixation_cross.tStop = t  # not accounting for scr refresh
                fixation_cross.frameNStop = frameN  # exact frame index
                win.timeOnFlip(fixation_cross, 'tStopRefresh')  # time at next scr refresh
                fixation_cross.setAutoDraw(False)
        
        # *feedback_stim* updates
        if feedback_stim.status == NOT_STARTED and tThisFlip >= 0.8-frameTolerance:
            # keep track of start time/frame for later
            feedback_stim.frameNStart = frameN  # exact frame index
            feedback_stim.tStart = t  # local t and not account for scr refresh
            feedback_stim.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(feedback_stim, 'tStartRefresh')  # time at next scr refresh
            feedback_stim.setAutoDraw(True)
        if feedback_stim.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > feedback_stim.tStartRefresh + 2-frameTolerance:
                # keep track of stop time/frame for later
                feedback_stim.tStop = t  # not accounting for scr refresh
                feedback_stim.frameNStop = frameN  # exact frame index
                win.timeOnFlip(feedback_stim, 'tStopRefresh')  # time at next scr refresh
                feedback_stim.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in feedbackComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "feedback"-------
    for thisComponent in feedbackComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    block3.addData('fixation_cross.started', fixation_cross.tStartRefresh)
    block3.addData('fixation_cross.stopped', fixation_cross.tStopRefresh)
    block3.addData('feedback_stim.started', feedback_stim.tStartRefresh)
    block3.addData('feedback_stim.stopped', feedback_stim.tStopRefresh)
    
    # ------Prepare to start Routine "ITI"-------
    continueRoutine = True
    # update component parameters for each repeat
    #randomly generate number from 0 to 1
    random_n = random()
    
    possible_times = [0.6, 0.7]
    
    #randomly pick which times to add randomly
    #generated number
    shuffle(possible_times)
    
    this_time = possible_times[0]
    
    #equation to get ITI
    ITI_time = this_time + random_n/10
    print(ITI_time)
    
    thisExp.addData ("ITI_time", ITI_time)
    # keep track of which components have finished
    ITIComponents = [ITI_stimulus]
    for thisComponent in ITIComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    ITIClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "ITI"-------
    while continueRoutine:
        # get current time
        t = ITIClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=ITIClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *ITI_stimulus* updates
        if ITI_stimulus.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            ITI_stimulus.frameNStart = frameN  # exact frame index
            ITI_stimulus.tStart = t  # local t and not account for scr refresh
            ITI_stimulus.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(ITI_stimulus, 'tStartRefresh')  # time at next scr refresh
            ITI_stimulus.setAutoDraw(True)
        if ITI_stimulus.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > ITI_stimulus.tStartRefresh + ITI_time-frameTolerance:
                # keep track of stop time/frame for later
                ITI_stimulus.tStop = t  # not accounting for scr refresh
                ITI_stimulus.frameNStop = frameN  # exact frame index
                win.timeOnFlip(ITI_stimulus, 'tStopRefresh')  # time at next scr refresh
                ITI_stimulus.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in ITIComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "ITI"-------
    for thisComponent in ITIComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    block3.addData('ITI_stimulus.started', ITI_stimulus.tStartRefresh)
    block3.addData('ITI_stimulus.stopped', ITI_stimulus.tStopRefresh)
    # the Routine "ITI" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 17.0 repeats of 'block3'


# ------Prepare to start Routine "end"-------
continueRoutine = True
# update component parameters for each repeat
# keep track of which components have finished
endComponents = [end_text]
for thisComponent in endComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
endClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "end"-------
while continueRoutine:
    # get current time
    t = endClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=endClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *end_text* updates
    if end_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        end_text.frameNStart = frameN  # exact frame index
        end_text.tStart = t  # local t and not account for scr refresh
        end_text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(end_text, 'tStartRefresh')  # time at next scr refresh
        end_text.setAutoDraw(True)
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in endComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "end"-------
for thisComponent in endComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('end_text.started', end_text.tStartRefresh)
thisExp.addData('end_text.stopped', end_text.tStopRefresh)
# the Routine "end" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv', delim='auto')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
if eyetracker:
    eyetracker.setConnectionState(False)
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
