﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2022.1.3),
    on May 25, 2023, at 11:12
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

from psychopy import locale_setup
from psychopy import prefs
from psychopy import sound, gui, visual, core, data, event, logging, clock, colors, layout
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle, choice as randchoice
import os  # handy system and path functions
import sys  # to get file system encoding

import psychopy.iohub as io
from psychopy.hardware import keyboard



# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)
# Store info about the experiment session
psychopyVersion = '2022.1.3'
expName = 'midEEG'  # from the Builder filename that created this script
expInfo = {'participant': '', 'session': '001'}
dlg = gui.DlgFromDict(dictionary=expInfo, sortKeys=False, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='C:\\Users\\selin\\Documents\\PhD\\Projects\\Community Study 1\\ERP Tasks\\BrainProducts\\MID Task - BP EEG\\midEEG_lastrun.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run after the window creation

# Setup the Window
win = visual.Window(
    size=[1920, 1080], fullscr=True, screen=0, 
    winType='pyglet', allowGUI=False, allowStencil=False,
    monitor='testMonitor', color=[0,0,0], colorSpace='rgb',
    blendMode='avg', useFBO=True, 
    units='height')
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess
# Setup ioHub
ioConfig = {}

# Setup iohub keyboard
ioConfig['Keyboard'] = dict(use_keymap='psychopy')

ioSession = '1'
if 'session' in expInfo:
    ioSession = str(expInfo['session'])
ioServer = io.launchHubServer(window=win, **ioConfig)
eyetracker = None

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard(backend='iohub')

# Initialize components for Routine "cue"
cueClock = core.Clock()
cue_condition = visual.ImageStim(
    win=win,
    name='cue_condition', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=[0.25, 0.25],
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=0.0)
anticipation = visual.TextStim(win=win, name='anticipation',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.15, wrapWidth=None, ori=0.0, 
    color=[-1.0000, -1.0000, -1.0000], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Initialize components for Routine "target"
targetClock = core.Clock()
#define initial response duration
resp_duration = 0.2
target_stim = visual.ImageStim(
    win=win,
    name='target_stim', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(0.24, 0.24),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-1.0)
target_mouse = event.Mouse(win=win)
x, y = [None, None]
target_mouse.mouseClock = core.Clock()

# Initialize components for Routine "feedback"
feedbackClock = core.Clock()
#define earning variables
total_earnings = 0
this_earnings = 0 
fixation_cross = visual.TextStim(win=win, name='fixation_cross',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.15, wrapWidth=None, ori=0.0, 
    color=[-1.0000, -1.0000, -1.0000], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
feedback_stim = visual.ImageStim(
    win=win,
    name='feedback_stim', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(0.25, 0.25),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=-2.0)

# Initialize components for Routine "ITI"
ITIClock = core.Clock()
ITI_stimulus = visual.TextStim(win=win, name='ITI_stimulus',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# set up handler to look after randomisation of conditions etc
trials = data.TrialHandler(nReps=50.0, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('condition.xlsx'),
    seed=None, name='trials')
thisExp.addLoop(trials)  # add the loop to the experiment
thisTrial = trials.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
if thisTrial != None:
    for paramName in thisTrial:
        exec('{} = thisTrial[paramName]'.format(paramName))

for thisTrial in trials:
    currentLoop = trials
    # abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
    if thisTrial != None:
        for paramName in thisTrial:
            exec('{} = thisTrial[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "cue"-------
    continueRoutine = True
    routineTimer.add(1.200000)
    # update component parameters for each repeat
    cue_condition.setImage(cue_type)
    # keep track of which components have finished
    cueComponents = [cue_condition, anticipation]
    for thisComponent in cueComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    cueClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "cue"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = cueClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=cueClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *cue_condition* updates
        if cue_condition.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            cue_condition.frameNStart = frameN  # exact frame index
            cue_condition.tStart = t  # local t and not account for scr refresh
            cue_condition.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(cue_condition, 'tStartRefresh')  # time at next scr refresh
            cue_condition.setAutoDraw(True)
        if cue_condition.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > cue_condition.tStartRefresh + 0.4-frameTolerance:
                # keep track of stop time/frame for later
                cue_condition.tStop = t  # not accounting for scr refresh
                cue_condition.frameNStop = frameN  # exact frame index
                win.timeOnFlip(cue_condition, 'tStopRefresh')  # time at next scr refresh
                cue_condition.setAutoDraw(False)
        
        # *anticipation* updates
        if anticipation.status == NOT_STARTED and tThisFlip >= 0.4-frameTolerance:
            # keep track of start time/frame for later
            anticipation.frameNStart = frameN  # exact frame index
            anticipation.tStart = t  # local t and not account for scr refresh
            anticipation.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(anticipation, 'tStartRefresh')  # time at next scr refresh
            anticipation.setAutoDraw(True)
        if anticipation.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > anticipation.tStartRefresh + 0.8-frameTolerance:
                # keep track of stop time/frame for later
                anticipation.tStop = t  # not accounting for scr refresh
                anticipation.frameNStop = frameN  # exact frame index
                win.timeOnFlip(anticipation, 'tStopRefresh')  # time at next scr refresh
                anticipation.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in cueComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "cue"-------
    for thisComponent in cueComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    trials.addData('cue_condition.started', cue_condition.tStartRefresh)
    trials.addData('cue_condition.stopped', cue_condition.tStopRefresh)
    trials.addData('anticipation.started', anticipation.tStartRefresh)
    trials.addData('anticipation.stopped', anticipation.tStopRefresh)
    
    # ------Prepare to start Routine "target"-------
    continueRoutine = True
    # update component parameters for each repeat
    #define correst response variable
    correct = 0
    
    randOnset = random() *(1.5 - 0.5) + 0.5
    thisExp.addData("randOnset", randOnset)
    target_stim.setImage('square.png')
    # setup some python lists for storing info about the target_mouse
    target_mouse.x = []
    target_mouse.y = []
    target_mouse.leftButton = []
    target_mouse.midButton = []
    target_mouse.rightButton = []
    target_mouse.time = []
    target_mouse.clicked_name = []
    gotValidClick = False  # until a click is received
    # keep track of which components have finished
    targetComponents = [target_stim, target_mouse]
    for thisComponent in targetComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    targetClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "target"-------
    while continueRoutine:
        # get current time
        t = targetClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=targetClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        #check correct response
        if t < 0.2: 
            if target_mouse.isPressedIn(target_stim):
                correct = 1
                continueRoutine = False
        else: 
            correct = 0 
            continueRoutine = False
        
        # *target_stim* updates
        if target_stim.status == NOT_STARTED and tThisFlip >= randOnset-frameTolerance:
            # keep track of start time/frame for later
            target_stim.frameNStart = frameN  # exact frame index
            target_stim.tStart = t  # local t and not account for scr refresh
            target_stim.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(target_stim, 'tStartRefresh')  # time at next scr refresh
            target_stim.setAutoDraw(True)
        if target_stim.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > target_stim.tStartRefresh + resp_duration-frameTolerance:
                # keep track of stop time/frame for later
                target_stim.tStop = t  # not accounting for scr refresh
                target_stim.frameNStop = frameN  # exact frame index
                win.timeOnFlip(target_stim, 'tStopRefresh')  # time at next scr refresh
                target_stim.setAutoDraw(False)
        # *target_mouse* updates
        if target_mouse.status == NOT_STARTED and t >= randOnset-frameTolerance:
            # keep track of start time/frame for later
            target_mouse.frameNStart = frameN  # exact frame index
            target_mouse.tStart = t  # local t and not account for scr refresh
            target_mouse.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(target_mouse, 'tStartRefresh')  # time at next scr refresh
            target_mouse.status = STARTED
            target_mouse.mouseClock.reset()
            prevButtonState = target_mouse.getPressed()  # if button is down already this ISN'T a new click
        if target_mouse.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > target_mouse.tStartRefresh + resp_duration-frameTolerance:
                # keep track of stop time/frame for later
                target_mouse.tStop = t  # not accounting for scr refresh
                target_mouse.frameNStop = frameN  # exact frame index
                win.timeOnFlip(target_mouse, 'tStopRefresh')  # time at next scr refresh
                target_mouse.status = FINISHED
        if target_mouse.status == STARTED:  # only update if started and not finished!
            buttons = target_mouse.getPressed()
            if buttons != prevButtonState:  # button state changed?
                prevButtonState = buttons
                if sum(buttons) > 0:  # state changed to a new click
                    # check if the mouse was inside our 'clickable' objects
                    gotValidClick = False
                    try:
                        iter(target_stim)
                        clickableList = target_stim
                    except:
                        clickableList = [target_stim]
                    for obj in clickableList:
                        if obj.contains(target_mouse):
                            gotValidClick = True
                            target_mouse.clicked_name.append(obj.name)
                    if gotValidClick:
                        x, y = target_mouse.getPos()
                        target_mouse.x.append(x)
                        target_mouse.y.append(y)
                        buttons = target_mouse.getPressed()
                        target_mouse.leftButton.append(buttons[0])
                        target_mouse.midButton.append(buttons[1])
                        target_mouse.rightButton.append(buttons[2])
                        target_mouse.time.append(target_mouse.mouseClock.getTime())
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in targetComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "target"-------
    for thisComponent in targetComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    if correct == 1:
        resp_duration -= 0.01
    else:
        resp_duration += 0.01
    
    #saving custon data to csv output
    thisExp.addData("resp_duration", resp_duration)
    trials.addData('target_stim.started', target_stim.tStartRefresh)
    trials.addData('target_stim.stopped', target_stim.tStopRefresh)
    # store data for trials (TrialHandler)
    trials.addData('target_mouse.x', target_mouse.x)
    trials.addData('target_mouse.y', target_mouse.y)
    trials.addData('target_mouse.leftButton', target_mouse.leftButton)
    trials.addData('target_mouse.midButton', target_mouse.midButton)
    trials.addData('target_mouse.rightButton', target_mouse.rightButton)
    trials.addData('target_mouse.time', target_mouse.time)
    trials.addData('target_mouse.clicked_name', target_mouse.clicked_name)
    trials.addData('target_mouse.started', target_mouse.tStart)
    trials.addData('target_mouse.stopped', target_mouse.tStop)
    # the Routine "target" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # ------Prepare to start Routine "feedback"-------
    continueRoutine = True
    routineTimer.add(2.800000)
    # update component parameters for each repeat
    #show different feedback depending on trial type
    #set trigger values based on trial type
    if trial_type == "incentive":
        if correct == 1:
            image_feedback = "win.jpg"
            this_earnings = 0.2
            feedback_trigger = 4
        else:
            image_feedback = "loss.png"
            this_earnings = -0.2
            feedback_trigger = 5
    else:
        image_feedback = "neutral.png"
        this_earnings = 0
        feedback_trigger = 6
    
    total_earnings = total_earnings + this_earnings
    thisExp.addData ("total_earnings", total_earnings)
    
    thisExp.addData("correct", correct)
    feedback_stim.setImage(image_feedback)
    # keep track of which components have finished
    feedbackComponents = [fixation_cross, feedback_stim]
    for thisComponent in feedbackComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    feedbackClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "feedback"-------
    while continueRoutine and routineTimer.getTime() > 0:
        # get current time
        t = feedbackClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=feedbackClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *fixation_cross* updates
        if fixation_cross.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            fixation_cross.frameNStart = frameN  # exact frame index
            fixation_cross.tStart = t  # local t and not account for scr refresh
            fixation_cross.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(fixation_cross, 'tStartRefresh')  # time at next scr refresh
            fixation_cross.setAutoDraw(True)
        if fixation_cross.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > fixation_cross.tStartRefresh + 0.8-frameTolerance:
                # keep track of stop time/frame for later
                fixation_cross.tStop = t  # not accounting for scr refresh
                fixation_cross.frameNStop = frameN  # exact frame index
                win.timeOnFlip(fixation_cross, 'tStopRefresh')  # time at next scr refresh
                fixation_cross.setAutoDraw(False)
        
        # *feedback_stim* updates
        if feedback_stim.status == NOT_STARTED and tThisFlip >= 0.8-frameTolerance:
            # keep track of start time/frame for later
            feedback_stim.frameNStart = frameN  # exact frame index
            feedback_stim.tStart = t  # local t and not account for scr refresh
            feedback_stim.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(feedback_stim, 'tStartRefresh')  # time at next scr refresh
            feedback_stim.setAutoDraw(True)
        if feedback_stim.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > feedback_stim.tStartRefresh + 2-frameTolerance:
                # keep track of stop time/frame for later
                feedback_stim.tStop = t  # not accounting for scr refresh
                feedback_stim.frameNStop = frameN  # exact frame index
                win.timeOnFlip(feedback_stim, 'tStopRefresh')  # time at next scr refresh
                feedback_stim.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in feedbackComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "feedback"-------
    for thisComponent in feedbackComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    trials.addData('fixation_cross.started', fixation_cross.tStartRefresh)
    trials.addData('fixation_cross.stopped', fixation_cross.tStopRefresh)
    trials.addData('feedback_stim.started', feedback_stim.tStartRefresh)
    trials.addData('feedback_stim.stopped', feedback_stim.tStopRefresh)
    
    # ------Prepare to start Routine "ITI"-------
    continueRoutine = True
    # update component parameters for each repeat
    #randomly generate number from 0 to 1
    random_n = random()
    
    possible_times = [0.6, 0.7]
    
    #randomly pick which times to add randomly
    #generated number
    shuffle(possible_times)
    
    this_time = possible_times[0]
    
    #equation to get ITI
    ITI_time = this_time + random_n/10
    print(ITI_time)
    
    thisExp.addData ("ITI_time", ITI_time)
    # keep track of which components have finished
    ITIComponents = [ITI_stimulus]
    for thisComponent in ITIComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    ITIClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "ITI"-------
    while continueRoutine:
        # get current time
        t = ITIClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=ITIClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *ITI_stimulus* updates
        if ITI_stimulus.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            ITI_stimulus.frameNStart = frameN  # exact frame index
            ITI_stimulus.tStart = t  # local t and not account for scr refresh
            ITI_stimulus.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(ITI_stimulus, 'tStartRefresh')  # time at next scr refresh
            ITI_stimulus.setAutoDraw(True)
        if ITI_stimulus.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > ITI_stimulus.tStartRefresh + ITI_time-frameTolerance:
                # keep track of stop time/frame for later
                ITI_stimulus.tStop = t  # not accounting for scr refresh
                ITI_stimulus.frameNStop = frameN  # exact frame index
                win.timeOnFlip(ITI_stimulus, 'tStopRefresh')  # time at next scr refresh
                ITI_stimulus.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in ITIComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "ITI"-------
    for thisComponent in ITIComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    trials.addData('ITI_stimulus.started', ITI_stimulus.tStartRefresh)
    trials.addData('ITI_stimulus.stopped', ITI_stimulus.tStopRefresh)
    # the Routine "ITI" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 50.0 repeats of 'trials'


# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv', delim='auto')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
if eyetracker:
    eyetracker.setConnectionState(False)
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
